/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 28.07.2015
Author  : 
Company : 
Comments: 


Chip type               : ATmega64
Program type            : Application
AVR Core Clock frequency: 4,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 1024
*******************************************************/
#include <stdio.h>
#include <mega64.h>
#include <alcd.h>
#include <delay.h>
#define DATA_REGISTER_EMPTY (1<<UDRE0)
#define RX_COMPLETE (1<<RXC0)
#define FRAMING_ERROR (1<<FE0)
#define PARITY_ERROR (1<<UPE0)
#define DATA_OVERRUN (1<<DOR0)
#define RX_BUFFER_SIZE0 8
char rx_buffer0[RX_BUFFER_SIZE0];
unsigned char g;
unsigned char h;
unsigned char i;
unsigned char data[1];
unsigned char count_int=0;
unsigned char Rx_End=0;
#if RX_BUFFER_SIZE0 <= 256
unsigned char rx_wr_index0=0,rx_rd_index0=0;
#else
unsigned int rx_wr_index0=0,rx_rd_index0=0;
#endif
#if RX_BUFFER_SIZE0 < 256
unsigned char rx_counter0=0;
#else
unsigned int rx_counter0=0;
#endif
bit rx_buffer_overflow0;
interrupt [USART0_RXC] void usart0_rx_isr(void)
{
data[count_int]=UDR0;
count_int++;
if (count_int==1)
{
count_int=0;
}

   }

#ifndef _DEBUG_TERMINAL_IO_
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter0==0);
data=rx_buffer0[rx_rd_index0++];
#if RX_BUFFER_SIZE0 != 256
if (rx_rd_index0 == RX_BUFFER_SIZE0) rx_rd_index0=0;
#endif
#asm("cli")
--rx_counter0;
#asm("sei")
return data;
}
#pragma used-
#endif


void main(void)
{
DDRA=(0<<DDA7) | (0<<DDA6) | (0<<DDA5) | (0<<DDA4) | (0<<DDA3) | (0<<DDA2) | (0<<DDA1) | (0<<DDA0);
PORTA=(0<<PORTA7) | (0<<PORTA6) | (0<<PORTA5) | (0<<PORTA4) | (0<<PORTA3) | (0<<PORTA2) | (0<<PORTA1) | (0<<PORTA0);
DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (0<<DDB1) | (0<<DDB0);
PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);
DDRC=(0<<DDC7) | (0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);
PORTC=(0<<PORTC7) | (0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (0<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0); 
PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);
DDRE=(0<<DDE7) | (0<<DDE6) | (0<<DDE5) | (1<<DDE4) | (0<<DDE3) | (0<<DDE2) | (0<<DDE1) | (0<<DDE0);
PORTE=(0<<PORTE7) | (0<<PORTE6) | (0<<PORTE5) | (0<<PORTE4) | (0<<PORTE3) | (0<<PORTE2) | (0<<PORTE1) | (0<<PORTE0); 
DDRF=(0<<DDF7) | (0<<DDF6) | (0<<DDF5) | (0<<DDF4) | (0<<DDF3) | (0<<DDF2) | (0<<DDF1) | (0<<DDF0);
PORTF=(0<<PORTF7) | (0<<PORTF6) | (0<<PORTF5) | (0<<PORTF4) | (0<<PORTF3) | (0<<PORTF2) | (0<<PORTF1) | (0<<PORTF0);
DDRG=(0<<DDG4) | (0<<DDG3) | (0<<DDG2) | (0<<DDG1) | (0<<DDG0);
PORTG=(0<<PORTG4) | (0<<PORTG3) | (0<<PORTG2) | (0<<PORTG1) | (0<<PORTG0);
ASSR=0<<AS0;
TCCR0=(0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (0<<CS01) | (0<<CS00);
TCNT0=0x00;
OCR0=0x00;
TCCR1A=(0<<COM1A1) | (0<<COM1A0) | (0<<COM1B1) | (0<<COM1B0) | (0<<COM1C1) | (0<<COM1C0) | (0<<WGM11) | (0<<WGM10);
TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (0<<WGM12) | (0<<CS12) | (0<<CS11) | (0<<CS10);
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
OCR1CH=0x00;
OCR1CL=0x00;
TCCR2=(0<<WGM20) | (0<<COM21) | (0<<COM20) | (0<<WGM21) | (0<<CS22) | (0<<CS21) | (0<<CS20);
TCNT2=0x00;
OCR2=0x00;
TCCR3A=(0<<COM3A1) | (0<<COM3A0) | (0<<COM3B1) | (0<<COM3B0) | (0<<COM3C1) | (0<<COM3C0) | (0<<WGM31) | (0<<WGM30);
TCCR3B=(0<<ICNC3) | (0<<ICES3) | (0<<WGM33) | (0<<WGM32) | (0<<CS32) | (0<<CS31) | (0<<CS30);
TCNT3H=0x00;
TCNT3L=0x00;
ICR3H=0x00;
ICR3L=0x00;
OCR3AH=0x00;
OCR3AL=0x00;
OCR3BH=0x00;
OCR3BL=0x00;
OCR3CH=0x00;
OCR3CL=0x00;
TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<OCIE0) | (0<<TOIE0);
ETIMSK=(0<<TICIE3) | (0<<OCIE3A) | (0<<OCIE3B) | (0<<TOIE3) | (0<<OCIE3C) | (0<<OCIE1C);
EICRA=(0<<ISC31) | (0<<ISC30) | (0<<ISC21) | (0<<ISC20) | (0<<ISC11) | (0<<ISC10) | (0<<ISC01) | (0<<ISC00);
EICRB=(0<<ISC71) | (0<<ISC70) | (0<<ISC61) | (0<<ISC60) | (0<<ISC51) | (0<<ISC50) | (0<<ISC41) | (0<<ISC40);
EIMSK=(0<<INT7) | (0<<INT6) | (0<<INT5) | (0<<INT4) | (0<<INT3) | (0<<INT2) | (0<<INT1) | (0<<INT0);
UCSR0A=(0<<RXC0) | (0<<TXC0) | (0<<UDRE0) | (0<<FE0) | (0<<DOR0) | (0<<UPE0) | (0<<U2X0) | (0<<MPCM0);
UCSR0B=(1<<RXCIE0) | (0<<TXCIE0) | (0<<UDRIE0) | (1<<RXEN0) | (1<<TXEN0) | (0<<UCSZ02) | (0<<RXB80) | (0<<TXB80);
UCSR0C=(0<<UMSEL0) | (0<<UPM01) | (0<<UPM00) | (0<<USBS0) | (1<<UCSZ01) | (1<<UCSZ00) | (0<<UCPOL0);
UBRR0H=0x00;
UBRR0L=0x19;
UCSR1B=(0<<RXCIE1) | (0<<TXCIE1) | (0<<UDRIE1) | (0<<RXEN1) | (0<<TXEN1) | (0<<UCSZ12) | (0<<RXB81) | (0<<TXB81);
ACSR=(1<<ACD) | (0<<ACBG) | (0<<ACO) | (0<<ACI) | (0<<ACIE) | (0<<ACIC) | (0<<ACIS1) | (0<<ACIS0);
SFIOR=(0<<ACME);
ADCSRA=(0<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (0<<ADPS0);
SPCR=(0<<SPIE) | (0<<SPE) | (0<<DORD) | (0<<MSTR) | (0<<CPOL) | (0<<CPHA) | (0<<SPR1) | (0<<SPR0);
TWCR=(0<<TWEA) | (0<<TWSTA) | (0<<TWSTO) | (0<<TWEN) | (0<<TWIE);
lcd_init(16);
#asm("sei")

while (1)
      { 
      if(PINC.0==1)
      {   
      PORTE.4=1;
      putchar(0b00001001);
      PORTE.4=0; 
      //lcd_gotoxy(6,0);
      //lcd_puts("");
      while(PINC.0==1)
      {;
      };
      } ;            
      if(PINC.1==1)
      {putchar(0b00001010);
      while(PINC.1==1)
      {;
      };
      }; 
       if(PINC.2==1)
      {putchar(0b10001000);
      while(PINC.2==1)
      {;
      };
      } ;
       if(PINC.3==1)
      {putchar(0b00101000);
      while(PINC.3==1)
      {;
      };
      };
      while(PINC.4==1)
      {
      putchar(0b01010000);
      delay_ms(250);
      lcd_gotoxy(6,1); lcd_puts("R");
      }; 
       while(PINC.5==1)
      {
      putchar(0b00010100);
      delay_ms(250);
      lcd_gotoxy(6,1); lcd_puts("L");
      };      
      putchar(0b11000000);//0b11000000   
      //lcd_clear();
      switch (data[0]) {
    case 0b00000000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("__----");
   
    break; 
    case 0b00000001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR");lcd_gotoxy(9,0);lcd_puts("_G_----");
    break; 
    case 0b00000010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
    break; 
    case 0b00000011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
    break;
    case 0b00000100:
     lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
    break;
    case 0b00000101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
    break; 
    case 0b00000110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
    break; 
    case 0b00000111:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
    break; 
    case 0b00001000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
    break;
    case  0b00001001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
    break; 
    case 0b00001010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR");
    break; 
    case 0b00001011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR");
    break;
     case 0b00001100:
    lcd_gotoxy(0,0);
   /* lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
    break;
    case  0b00001101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
    break; 
    case 0b00001110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
    break; 
    case 0b00001111:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");
    break;
    case 0b00010000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00010001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00010010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");     
    break;
    case 0b00010011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");    
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case 0b00010100:
     lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case 0b00010101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00010110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00010111:

     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00011000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case  0b00011001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00011010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR"); 
    lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case 0b00011011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR"); 
      lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
     case 0b00011100:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----"); 
      lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case  0b00011101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
      lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break; 
    case 0b00011110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----"); 
      lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case 0b00011111:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");  
      lcd_gotoxy(8,1);
    lcd_puts("_____RPM");
    break;
    case 0b00100000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00100001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00100010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
    lcd_gotoxy(8,1);
    lcd_puts("START___");     
    break;
    case 0b00100011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");    
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
    case 0b00100100:
     lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
    case 0b00100101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00100110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00100111:

     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00101000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
    case  0b00101001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00101010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR"); 
    lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
    case 0b00101011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR"); 
      lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
     case 0b00101100:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----"); 
      lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
    case  0b00101101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
      lcd_gotoxy(8,1);
    lcd_puts("START___");
    break; 
    case 0b00101110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----"); 
      lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
    case 0b00101111:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");  
      lcd_gotoxy(8,1);
    lcd_puts("START___");
    break;
case 0b00110000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___----");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00110001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00110010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");     
    break;
    case 0b00110011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");    
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    case 0b00110100:
     lcd_gotoxy(0,0);
    /*lcd_puts("_");*/ lcd_gotoxy(9,0);lcd_puts("___KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    case 0b00110101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00110110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00110111:

     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_KRUG");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00111000:
    lcd_gotoxy(0,0);
    /*lcd_puts("___");*/ lcd_gotoxy(9,0);lcd_puts("___NAPR");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    case  0b00111001:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_NAPR");
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00111010:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__NAPR"); 
    lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    case 0b00111011:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_NAPR"); 
      lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
     case 0b00111100:
    lcd_gotoxy(0,0);
    /*lcd_puts("___"); */lcd_gotoxy(9,0);lcd_puts("___----"); 
      lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    case  0b00111101:
    lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("_G_----");
      lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break; 
    case 0b00111110:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("N__----"); 
      lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    case 0b00111111:
     lcd_gotoxy(0,0);
    lcd_puts("ERR"); lcd_gotoxy(9,0);lcd_puts("NG_----");  
      lcd_gotoxy(8,1);
    lcd_puts("STARTRPM");
    break;
    default:
    lcd_gotoxy(12,1);
    //lcd_puts("fail");

    }; 
    putchar(0b00101010);//0b00101010
    switch(data[0]){
    case 0b01000000: lcd_gotoxy(3,0);lcd_puts("______");break;     
    case 0b01000001: lcd_gotoxy(0,0);lcd_puts("ERR_____p");break;
    case 0b01000010: lcd_gotoxy(0,0);lcd_puts("ERR____P_");break; 
    case 0b01000011: lcd_gotoxy(0,0);lcd_puts("ERR____Pp");break; 
    case 0b01000100: lcd_gotoxy(0,0);lcd_puts("ERR___4__");break; 
    case 0b01000101: lcd_gotoxy(0,0);lcd_puts("ERR___4_p");break; 
    case 0b01000110: lcd_gotoxy(0,0);lcd_puts("ERR___4P_");break; 
    case 0b01000111: lcd_gotoxy(0,0);lcd_puts("ERR___4_p");break; 
    case 0b01001000: lcd_gotoxy(0,0);lcd_puts("ERR__3___");break; 
    case 0b01001001: lcd_gotoxy(0,0);lcd_puts("ERR__3__p");break; 
    case 0b01001010: lcd_gotoxy(0,0);lcd_puts("ERR__3_P_");break; 
    case 0b01001011: lcd_gotoxy(0,0);lcd_puts("ERR__3_Pp");break; 
    case 0b01001100: lcd_gotoxy(0,0);lcd_puts("ERR__34__");break;
    case 0b01001101: lcd_gotoxy(0,0);lcd_puts("ERR__34_p");break; 
    case 0b01001110: lcd_gotoxy(0,0);lcd_puts("ERR__34P_");break; 
    case 0b01001111: lcd_gotoxy(0,0);lcd_puts("ERR__34Pp");break; 
    case 0b01010000: lcd_gotoxy(0,0);lcd_puts("ERR_2____");break;
    case 0b01010001: lcd_gotoxy(0,0);lcd_puts("ERR_2___p");break; 
    case 0b01010010: lcd_gotoxy(0,0);lcd_puts("ERR_2__P_");break; 
    case 0b01010011: lcd_gotoxy(0,0);lcd_puts("ERR_2__Pp");break; 
    case 0b01010100: lcd_gotoxy(0,0);lcd_puts("ERR_2_4__");break; 
    case 0b01010101: lcd_gotoxy(0,0);lcd_puts("ERR_2_4_p");break; 
    case 0b01010110: lcd_gotoxy(0,0);lcd_puts("ERR_2_4P_");break; 
    case 0b01010111: lcd_gotoxy(0,0);lcd_puts("ERR_2_4Pp");break; 
    case 0b01011000: lcd_gotoxy(0,0);lcd_puts("ERR_23___");break; 
    case 0b01011001: lcd_gotoxy(0,0);lcd_puts("ERR_23__p");break;
    case 0b01011010: lcd_gotoxy(0,0);lcd_puts("ERR_23_P_");break; 
    case 0b01011011: lcd_gotoxy(0,0);lcd_puts("ERR_23_Pp");break; 
    case 0b01011100: lcd_gotoxy(0,0);lcd_puts("ERR_234__");break; 
    case 0b01011101: lcd_gotoxy(0,0);lcd_puts("ERR_234_p");break;
    case 0b01011110: lcd_gotoxy(0,0);lcd_puts("ERR_234P_");break; 
    case 0b01011111: lcd_gotoxy(0,0);lcd_puts("ERR_234Pp");break; 
    case 0b01100000: lcd_gotoxy(0,0);lcd_puts("ERR1_____");break; 
    case 0b01100001: lcd_gotoxy(0,0);lcd_puts("ERR1____p");break; 
    case 0b01100010: lcd_gotoxy(0,0);lcd_puts("ERR1___P_");break; 
    case 0b01100011: lcd_gotoxy(0,0);lcd_puts("ERR1___Pp");break;
    case 0b01100100: lcd_gotoxy(0,0);lcd_puts("ERR1__4__");break; 
    case 0b01100101: lcd_gotoxy(0,0);lcd_puts("ERR1__4_p");break; 
    case 0b01100110: lcd_gotoxy(0,0);lcd_puts("ERR1__4P_");break; 
    case 0b01100111: lcd_gotoxy(0,0);lcd_puts("ERR1__4Pp");break; 
    case 0b01101000: lcd_gotoxy(0,0);lcd_puts("ERR1_3___");break; 
    case 0b01101001: lcd_gotoxy(0,0);lcd_puts("ERR1_3__p");break; 
    case 0b01101010: lcd_gotoxy(0,0);lcd_puts("ERR1_3_P_");break; 
    case 0b01101011: lcd_gotoxy(0,0);lcd_puts("ERR1_3_Pp");break;
    case 0b01101100: lcd_gotoxy(0,0);lcd_puts("ERR1_34__");break; 
    case 0b01101101: lcd_gotoxy(0,0);lcd_puts("ERR1_34_p");break; 
    case 0b01101110: lcd_gotoxy(0,0);lcd_puts("ERR1_34P_");break; 
    case 0b01101111: lcd_gotoxy(0,0);lcd_puts("ERR1_34Pp");break;
    case 0b01110000: lcd_gotoxy(0,0);lcd_puts("ERR12____");break; 
    case 0b01110001: lcd_gotoxy(0,0);lcd_puts("ERR12___p");break; 
    case 0b01110010: lcd_gotoxy(0,0);lcd_puts("ERR12__P_");break; 
    case 0b01110011: lcd_gotoxy(0,0);lcd_puts("ERR12__Pp");break; 
    case 0b01110100: lcd_gotoxy(0,0);lcd_puts("ERR12_4__");break; 
    case 0b01110101: lcd_gotoxy(0,0);lcd_puts("ERR12_4_p");break; 
    case 0b01110110: lcd_gotoxy(0,0);lcd_puts("ERR12_4P_");break; 
    case 0b01110111: lcd_gotoxy(0,0);lcd_puts("ERR12_4Pp");break;
    case 0b01111000: lcd_gotoxy(0,0);lcd_puts("ERR123___");break; 
    case 0b01111001: lcd_gotoxy(0,0);lcd_puts("ERR123__p");break; 
    case 0b01111010: lcd_gotoxy(0,0);lcd_puts("ERR123_P_");break; 
    case 0b01111011: lcd_gotoxy(0,0);lcd_puts("ERR123_Pp");break; 
    case 0b01111100: lcd_gotoxy(0,0);lcd_puts("ERR1234__");break; 
    case 0b01111101: lcd_gotoxy(0,0);lcd_puts("ERR1234_p");break; 
    case 0b01111110: lcd_gotoxy(0,0);lcd_puts("ERR1234P_");break; 
    case 0b01111111: lcd_gotoxy(0,0);lcd_puts("ERR1234Pp");break; 
    default: lcd_gotoxy(12,1); //lcd_puts("FAIL"); 
                        
    }
    
    //putchar(0b00110010);
   // unsigned char azimuth=data[0]&(0b01111111);
    //int azimuth=(int)angle*2.8125;
    lcd_gotoxy(0,1);
    lcd_puts("AZ:");
    
    
      
    

      
}
}
